MODULE_NAME='UUI COMM v1_00'	(dev dvUUI, dev vdaUUI_Ext[])
////////////////////////////////////////////////////////////////////////////////
//                                              Editor Settings: Tab=3, Indent=3
//                #############                 ================================
//            ######################                                            
//         ############################                                         
//       ################################                                       
//     ############            ############                                     
//    ###########                ###########                                    
//   ##########                    ##########                                   
//  ##########                      ##########                                  
//  #########                        #########                                  
//  #########           ####         #########                                  
//  #########         ########       #########                                  
//  ##########         ########     #########   Unique Automation               
//   ##########          ########     ######    12-14 Orion Business Centre     
//    ###########          ########     ###     Surrey Canal Rd                 
//     ############          ########           London                          
//       ################     ########          SE14 5RT                        
//         ################     ########                                        
//            ###############     ########      t: +44 (020) 7740 3910          
//                #############     ########    f: +44 (020) 7232 0972          
//                                    ####      e: info@uniqueautomation.co.uk  
//                                                                              
//                                    (c) Copyright Unique Automation Ltd 2012  
////////////////////////////////////////////////////////////////////////////////
//
// UUI (Communication Module)
//
////////////////////////////////////////////////////////////////////////////////
// Revision History
// -----------------------------------------------------------------------------
//
// v1.00 REH	31/07/12  Initial release based on UUI Host Interface 19 Oct 11
//
//
////////////////////////////////////////////////////////////////////////////////
(*
Notes:





--------------------------------------------------------------------------------
Legal information
--------------------------------------------------------------------------------
Unique Automantion grants you a nonexclusive  license to use this programming
code example from which you can generate similar function tailored to your own
specific needs.

All code is provided by Unique Automation for illustrative purposes only.
These examples have not been thoroughly tested under all conditions.
Unique Automation, therefore, cannot guarantee or imply reliability,
serviceability, or function of these programs.

The following code is provided to you "AS IS" without any warranties of any kind.
The implied warranties of non-infringement, merchantability and fitness for a
particular purpose are expressly disclaimed.
--------------------------------------------------------------------------------
*)


#include 'SNAPI'



//##############################################################################
DEFINE_DEVICE							//#############################################
//##############################################################################

//Create internal virtual devices
vdUUI_Int_01 = dynamic_virtual_device
vdUUI_Int_02 = dynamic_virtual_device
vdUUI_Int_03 = dynamic_virtual_device
vdUUI_Int_04 = dynamic_virtual_device
vdUUI_Int_05 = dynamic_virtual_device
vdUUI_Int_06 = dynamic_virtual_device
vdUUI_Int_07 = dynamic_virtual_device
vdUUI_Int_08 = dynamic_virtual_device





//##############################################################################
DEFINE_CONSTANT						//#############################################
//##############################################################################

//Device configuration
integer	nNUMUUI						= 8

integer	nNUMBUTTONS					= 32
integer	nNUMSWIPES					= 4
integer	nNUMSLIDERS					= 3

integer	nNUMPAGES					= 6
integer	nNUMPOPUPS					= 1

//Protocol constants
char		cFEND							= $C0
char		cFESC							= $DB
char		cTFEND						= $DC
char		cTFESC						= $DD

integer	cmdPANEL_BRIGHTNESS[]	= {$02,$04}
integer	cmdSLIDER_RANGE[]			= {$02,$05}
integer	cmdECO_ON[]					= {$02,$11}
integer	cmdECO_OFF[]				= {$02,$12}
integer	cmdFIELD_ON[]				= {$02,$28}
integer	cmdFIELD_OFF[]				= {$02,$29}
integer	cmdFIELD_PULSE[]			= {$02,$30}
integer	cmdTEXT_WRITE[]			= {$02,$31}
integer	cmdTEXT_ALIGHNMENT[]		= {$02,$32}
integer	cmdPAGE_ACTIVATE[]		= {$02,$33}
integer	cmdPOPUP_ACVTIVTE[]		= {$02,$34}
integer	cmdPOPUP_DEACTIVATE[]	= {$02,$35}
integer	cmdBAR_WRITE[]				= {$02,$36}


//Misc
integer	nPUSHED						= 1
integer	nRELEASED					= 2

long		nBITMASK32[]				= {$00000001, $00000002, $00000004, $00000008,
												$00000010, $00000020, $00000040, $00000080,
												$00000100, $00000200, $00000400, $00000800,
												$00001000, $00002000, $00004000, $00008000,
												$00010000, $00020000, $00040000, $00080000,
												$00100000, $00200000, $00400000, $00800000,
												$01000000, $02000000, $04000000, $08000000,
												$10000000, $20000000, $40000000, $80000000}



sinteger	snGTLOW						= -50		//Gesture Threshold (Low)
sinteger	snGTHIGH						=  50		//Gesture Threshold (High)

//##############################################################################
DEFINE_TYPE								//#############################################
//##############################################################################

struct	_UUI
{
	integer	nBtn[nNUMBUTTONS + nNUMSWIPES]				//Holds last know state of button & swipe channels
	sinteger	nSliderRaw[nNUMSLIDERS]							//Holds last know state of sliders
	integer	nSliderResetRange[nNUMSLIDERS]				//Holds last know ammount by which slider changed
	
	
	integer	nSliderStep[nNUMSLIDERS]						//Holds the current inc/dec step size (x10)
	integer	nSliderScaled[nNUMSLIDERS]						//Holds current scaled sliders value (0-100)
	
	integer	nWaiting												//True if waiting for response from unit
	
	integer	nTouchIndex											//Multitouch index number 1..3
	long		lTouchTL[3]											//Timeline ID for button pushes [nTouchIndex]
	integer	nTouchBtn[3]										//Button number [nTouchIndex]
}


struct	_Queue
{
	integer	nMaxLen												//Maximum length of queue
	integer	nStart												//Start of queue
	integer	nLength												//Length of queue
	integer	nBusy													//True if queue is busy
	integer	nTimeout												//Maximum time (1/10sec) for busy
}


struct	_TxData
{
	integer	nAddress												//Device address
	char		sMessage[64]										//Message
	integer	nAttempts											//Number of remaining attempts
}





//##############################################################################
DEFINE_VARIABLE						//#############################################
//##############################################################################

volatile char			sRxUUI[2040]									//Buffer for incoming data from UUI [nNUMUUI * 255]	

volatile dev			vdaUUI_Int[nNUMUUI]							//Array of 'Internal' UUI devices

volatile _UUI			xUUI[nNUMUUI]									//Array of UUI device status info

volatile integer		nInhibitComms			= 0					//True when comms to UUI are
																				//inhibited during startup

volatile integer		nDebug					= $ff	//0					//True if debug mode enabled
volatile char	  		sDebugMsg[255]

constant long			tlLockOut[]				= {1, 2, 3}
constant long			taLockOut[]				= {750}

//RS485 Queue variables
volatile _Queue		xTxQueue
volatile _TxData		xTxQueueData[384]								//[nNUMUUI * 48]





//##############################################################################
DEFINE_LATCHING						//#############################################
//##############################################################################





//##############################################################################
DEFINE_MUTUALLY_EXCLUSIVE			//#############################################
//##############################################################################





//##############################################################################
//CALLS & FUNCTIONS					//#############################################
//##############################################################################

define_function fnDebug(integer nLevel, char sData[])
{
	//Simple debug message handler (remove any $00's)
	If((nLevel band nDebug) <> 0)
	{
		stack_var char		sReturn[255]
		stack_var integer nIndex
		stack_var integer	nLen
		
		nLen = length_string(sData)
		
		for(nIndex = 1; nIndex <= nLen; nIndex++)
		{
			select
			{
				active(sData[nIndex] > $7E):	{sReturn = "sReturn, '$', format('%02x',sData[nIndex])"}
				active(sData[nIndex] < $20):	{sReturn = "sReturn, '$', format('%02x',sData[nIndex])"}
				active(1):							{sReturn = "sReturn, sData[nIndex]"}
			}
		}
		
		while(length_string(sReturn) > 128)
		{
			send_string 0,"get_buffer_string(sReturn,128)"
		}
		send_string 0,"sReturn"
	}
}


define_function char[255] fnDebugHex(integer nLevel, char sData[])
{
	stack_var char		sReturn[255]
	If((nLevel band nDebug) <> 0)
	{
		//formats data as hex bytes /xx/xx/xx.....
		stack_var integer nIndex
		stack_var integer	nLen
		
		nLen = length_string(sData)
		
		for(nIndex = 1; nIndex <= nLen; nIndex++)
		{
			sReturn = "sReturn, '/', format('%02x',sData[nIndex])"
		}
	}
	return sReturn
}










define_function fnTxQueue_Init ()
{
	xTxQueue.nMaxLen	= max_length_array(xTxQueueData)
	xTxQueue.nStart	= 0
	xTxQueue.nLength	= 0
	xTxQueue.nBusy		= 0
	xTxQueue.nTimeout	= 5	//0.5 sec timeout
}


define_function fnTxQueue_Add (integer nAddr, char sMsg[], integer nAttempts)
{
	stack_var integer nEnd
	
	nEnd = (xTxQueue.nStart + xTxQueue.nLength) % xTxQueue.nMaxLen
	nEnd = nEnd + 1					//Correct for zero based indexes
	
	//Write data to queue
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	
	xTxQueueData[nEnd].nAddress	= nAddr
	xTxQueueData[nEnd].sMessage	= sMsg
	xTxQueueData[nEnd].nAttempts	= max_value(nAttempts, 1)

	//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	//Update queue paramiters
	if(xTxQueue.nLength == xTxQueue.nMaxLen)
	{
		//Queue was already full. Oldest data overwritten!  Adjust start index accoringly.
		xTxQueue.nStart = (xTxQueue.nStart + 1) % xTxQueue.nMaxLen
		fnDebug(1, 'UUI_COM - fnTxQueue_Add: Max queue length exceeded!')
	}
	else
	{
		xTxQueue.nLength++
	}
}


define_function fnTxQueue_Process ()
{
	stack_var integer nStart
	
	if((xTxQueue.nLength > 0) and (xTxQueue.nBusy == 0))
	{
		nStart = xTxQueue.nStart + 1	//Correct for zero based indexes
		
		//Check to see if we have exceeded send attempts.  If so move on to next message (if there is one)
		if(xTxQueueData[nStart].nAttempts == 0)
		{
			xTxQueue.nLength--
			
			if(xTxQueue.nLength > 0)
			{
				xTxQueue.nStart = (xTxQueue.nStart + 1) % xTxQueue.nMaxLen
				nStart = xTxQueue.nStart + 1	//Correct for zero based indexes
			}
		}
		
		//Send message
		if(xTxQueue.nLength > 0)
		{
			xTxQueue.nBusy		= 1
			
			//Process queue
			//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
			
			fnSendCmd(xTxQueueData[nStart].nAddress, xTxQueueData[nStart].sMessage)
			
			//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			
			wait xTxQueue.nTimeout 'TxQueue Timeout'
			{
				xTxQueue.nBusy = 0
				fnDebug(1, "'UUI_COM - fnTxQueue_Process: Queue timeout!'")
			}
			
			xTxQueueData[nStart].nAttempts--
		}
	}
}


Define_Function fnTxQueue_Next ()
{
	cancel_wait 'TxQueue Timeout'
	
	if(xTxQueue.nLength > 0)
	{
		xTxQueue.nStart = (xTxQueue.nStart + 1) % xTxQueue.nMaxLen
		xTxQueue.nLength--
	}
	
	xTxQueue.nBusy = 0
}


Define_Function fnTxQueue_Retry ()
{
	cancel_wait 'TxQueue Timeout'
	
	xTxQueue.nBusy = 0
}










define_function char[255] fnEncode(char sData[])
{
	//Decode any encoded chars in message
	stack_var char	cTmp
	stack_var char	sDecoded[255]
	stack_var char	sEncoded[255]
	
	sDecoded = sData
	
	while(length_string(sDecoded))
	{
		cTmp = get_buffer_char(sDecoded)
		switch(cTmp)
		{
			case cFEND:	sEncoded = "sEncoded, cFESC, cTFEND"
			case cFESC:	sEncoded = "sEncoded, cFESC, cTFESC"
			default:		sEncoded = "sEncoded, cTmp"
		}
	}
	
	return sEncoded
}


define_function	fnSendCmd(integer nDest, char sData[])
{
	stack_var integer	nLen
	stack_var char		sMsg[255]
	stack_var integer	nChk
	
	//Build basic message (SRC, LEN, DST, DATA)
	nLen = length_string(sData)
	sMsg = "$00, raw_be(nLen), nDest, sData"
	
	//Add checksum
	for(nLen = length_string(sMsg); nLen; nLen--)	{nChk = nChk + sMsg[nLen]}
	nChk = (bnot(nChk) band $ff) + 1		#warn'should take bitwise band $FF after adding 1'
	sMsg = "sMsg, nChk"
	
	sDebugMsg = "cFEND, sMsg, cFEND"
	fnDebug(2, "'UUI_COM fnSendCmd: Tx [', sMsg, ']'")
	fnDebug(8, "'UUI_COM fnSendCmd: Tx Enc [', fnDebugHex(4, sDebugMsg), ']'")
	
	//Encode any escaped chars
	sMsg = fnEncode(sMsg)
	
	//Set timeout flag for specified unit if not already waiting
	if(xUUI[nDest].nWaiting == 0)	xUUI[nDest].nWaiting = 10	//Wait 10 seconds before flagging offline
	
	sMsg = "cFEND, sMsg, cFEND"
	//Send message
	send_string dvUUI,"sMsg"
	
	fnDebug(4, "'UUI_COM fnSendCmd: Tx Raw [', fnDebugHex(4, sMsg), ']'")
}










define_function char[255] fnDecode(char sData[])
{
	//Decode any encoded chars in message
	stack_var char	cTmp
	stack_var char	sEncoded[255]
	stack_var char	sDecoded[255]
	
	sEncoded = sData
	
	while(length_string(sEncoded))
	{
		cTmp = get_buffer_char(sEncoded)
		if(cTmp <> cFESC)
		{
			//Standard char add to decoded message
			sDecoded = "sDecoded, cTmp"
		}
		else
		{
			//Escaped char need to decode
			cTmp = get_buffer_char(sEncoded)
			
			switch(cTmp)
			{
				case cTFEND:	sDecoded = "sDecoded, cFEND"
				case cTFESC:	sDecoded = "sDecoded, cFESC"
				default:			{}//Invalid escaped char
			}
		}
	}
	
	return sDecoded
}


define_function fnParseUUI()
{
	//Parse data coming from UUI
	
	stack_var integer	nIncomplete
	stack_var integer	nTmp
	stack_var char		cTmp
	stack_var char		sMsg[255]
	
	stack_var integer	nSrc
	stack_var integer	nLen
	stack_var integer	nDst
	stack_var integer	nCmd
	
	stack_var integer	nNewBtnState
	
	while((length_string(sRxUUI) <> 0) and (!nIncomplete))
	{
		//Look for opening FEND char
		if(sRxUUI[1] <> cFEND)
		{
			//Junk next char in buffer
			cTmp = get_buffer_char(sRxUUI)
		}
		else
		{
			//We have a candidate message.  Look for closing FEND
			nTmp = find_string(sRxUUI, "cFEND", 2)
			
			select
			{
				active(nTmp == 0):
				{
					//Do not appear to have a complete message yet
					//Try again when next message received
					nIncomplete = 1
					fnDebug(1, "'UUI_COM - fnParseUUI: Message in buffer Incomplete!'")
				}
				
				active(nTmp < 7):
				{
					//Message is not long enough.  Junk this FEND
					cTmp = get_buffer_char(sRxUUI)
					fnDebug(1, "'UUI_COM - fnParseUUI: Message in buffer too short!'")
				}
				
				active(1):
				{
					//We have a message
					cTmp = get_buffer_char(sRxUUI)							//Trim leading FEND
					sMsg = remove_string(sRxUUI, "cFEND", 1)				//Get message
					set_length_string(sMsg, length_string(sMsg) - 1)	//Trim tailing FEND
					
					sDebugMsg = "cFEND, sMsg, cFEND"
					fnDebug(4, "'UUI_COM fnParseUUI: Rx Raw [', fnDebugHex(4, sDebugMsg), ']'")

					//Decode any encoded chars
					sMsg = fnDecode(sMsg)
					
					sDebugMsg = "cFEND, sMsg, cFEND"
					fnDebug(2, "'UUI_COM fnParseUUI: Rx [', sDebugMsg, ']'")
					fnDebug(8, "'UUI_COM fnParseUUI: Rx Dec [', fnDebugHex(4, sDebugMsg), ']'")
					
					//Start to parse message
					
					nSrc = get_buffer_char(sMsg)
					
					nLen = (get_buffer_char(sMsg) * $100) + get_buffer_char(sMsg)
					
					nDst = get_buffer_char(sMsg)
					
					nCmd = (sMsg[1] * $100) + sMsg[2]
					
					if((nSrc > 0) and (nSrc <= length_array(vdaUUI_Ext)))
					
					{
						//Device is online.
						xUUI[nSrc].nWaiting = 0	//Clear timeout flag for specified unit
						on[vdaUUI_Int[nSrc], DEVICE_COMMUNICATING]	//Set online channel
						on[vdaUUI_Int[nSrc], DATA_INITIALIZED]						
						
						switch(nCmd)
						{
							//----------------------------------------------------
							case	$0002:	//Ack
							//----------------------------------------------------
							{
								fnDebug(16, "'UUI_COM fnParseUUI: ACK #', itoa(nSrc)")
								
								fnTxQueue_Next()
							}
							
							
							
							//----------------------------------------------------
							case	$0003:	//Nak
							//----------------------------------------------------
							{
								fnDebug(16, "'UUI_COM fnParseUUI: NAK #', itoa(nSrc)")
								
								fnTxQueue_Retry()
							}
							
							
							
							//----------------------------------------------------
							case	$0221:	//Touch_Event_Rep
							//----------------------------------------------------
							{
								stack_var long			lPressed
								stack_var long			lChanged
								stack_var long			snLXY
								stack_var Sinteger	nSlider[3]
								stack_var Sinteger	nXPos
								stack_var Sinteger	nYPos
								stack_var integer		nBit
								stack_var integer		nNumPressed
								stack_var integer		nSliderChanged
								
								//Pressed buttons
								lPressed		= ((sMsg[ 3] << 24) +
													(sMsg[ 4] << 16) +
													(sMsg[ 5] << 08) +
													(sMsg[ 6]))
								
								//Changed buttons
								lChanged		= ((sMsg[ 7] << 24) +
													(sMsg[ 8] << 16) +
													(sMsg[ 9] << 08) +
													(sMsg[10]))
								
								//Rotary sliders 1..3 (+/-127)
								If(sMsg[11] > 128)	nSlider[1]	= Type_Cast(sMsg[11] - 256)
								Else						nSlider[1]	= Type_Cast(sMsg[11])
								
								
								If(sMsg[12] > 128)	nSlider[2]	= Type_Cast(sMsg[12] - 256)
								Else						nSlider[2]	= Type_Cast(sMsg[12])
								
								If(sMsg[13] > 128)	nSlider[3]	= Type_Cast(sMsg[13] - 256)
								Else						nSlider[3]	= Type_Cast(sMsg[13])
								
								//Liner Slider X (+/-255)
								snLXY 		= ((sMsg[14] << 08) +
													(sMsg[15]))
								If(snLXY > 256)		nXPos			= Type_Cast(snLXY - 65536)
								Else						nXPos			= Type_Cast(snLXY)
								
								//Liner Slider Y (+/-255)
								snLXY 		= ((sMsg[16] << 08) +
													(sMsg[17]))
								If(snLXY > 256)		nYPos			= Type_Cast(snLXY - 65536)
								Else						nYPos			= Type_Cast(snLXY)
								
								
	
								//Priority for control actions returned to main program are as as follows:
								//------------------------------------------------------------------------
								//	1.	Button Release
								//		Any release should be actioned immediatly
								//
								//	2.	Rotary Slider
								//
								// 3. Gesture
								//
								//	4. Button Press
								//
								
								
								
								
								
								
								
								
								//Rotary Sliders
								{
									stack_var integer		nIndex
									stack_var sinteger	nSliderScaled_old
									stack_var sinteger	nSliderRaw_old
									stack_var sinteger	nSliderDelta
									stack_var sinteger	nStep
									stack_var sinteger	nSliderNew
									stack_var char			sTmp[255]
									
									
									
																		
									for(nIndex = nNUMSLIDERS; nIndex; nIndex--)
									{
										//Get previous values
										nSliderScaled_old 				= type_cast(xUUI[nSrc].nSliderScaled[nIndex])
										
										nSliderRaw_old 					= xUUI[nSrc].nSliderRaw[nIndex]
										xUUI[nSrc].nSliderRaw[nIndex]	= nSlider[nIndex]
										
										//Calculate delta from previous raw value
										nSliderDelta 						= nSlider[nIndex] - nSliderRaw_old
										
										//Build diagnostic message
										(*
										sTmp = "'*** SLIDER  nSrc=', itoa(nSrc), 
																'  nIndex=', itoa(nIndex),
																'  nSlider[nIndex]=',	format('%+4d', nSlider[nIndex]),
																'  nSliderRaw_old=', 	format('%+4d', nSliderRaw_old),
																'  nSliderDelta=', 		format('%+4d', nSliderDelta),
																'  nSliderScaled_old=', format('%3d', nSliderScaled_old)"
										*)
										sTmp = ""
										
										
										//Increment step size
										xUUI[nSrc].nSliderStep[nIndex] = xUUI[nSrc].nSliderStep[nIndex] + 2
										if(xUUI[nSrc].nSliderStep[nIndex] > 50)	{xUUI[nSrc].nSliderStep[nIndex] = 50}
										
										//Reset step size if finger had veen removed
										//!if((nSlider[nIndex] == 0) and (nSliderRaw_old == 0))
										if(!timeline_active(tlLockOut[nSrc]))		{xUUI[nSrc].nSliderStep[nIndex] = 10}
										
										//Set actual value of step size (each step repeated 5 times)
										nStep = type_cast(xUUI[nSrc].nSliderStep[nIndex] / 10)
										
										
										
										//Unit returns 0 if user lifts finger or flipped at -127 or +128
										if(nSlider[nIndex] <> 0)
										{
											//prevent gestures and button presses
											fnLockOut(nSrc, 1)
											
											select
											{
												active(nSliderDelta > 0):	//Increment
												{
													if(nSliderScaled_old <= (100 - nStep))		{nSliderNew = nSliderScaled_old + nStep}
													else													{nSliderNew = 100}
												}
												active(nSliderDelta < 0): //Decrement
												{
													if(nSliderScaled_old >= (0 + nStep))		{nSliderNew = nSliderScaled_old - nStep}
													else													{nSliderNew = 0}
												}
												active(1):
												{
													nSliderNew = nSliderScaled_old
												}
											}
											
											xUUI[nSrc].nSliderScaled[nIndex]	= type_cast(nSliderNew)
											
											sTmp = "'*** SLIDER  nSrc=', itoa(nSrc), '  nIndex=', itoa(nIndex)"
											sTmp = "sTmp, ' Level=', format('%3d', nSliderNew), ' ~', itoa(nStep)"
											
											//Update levels in main program
											send_level vdaUUI_Int[nSrc], nIndex, nSliderNew
										}
										
										//!send_string 0,"sTmp"
									}
								}
	
	
	
								
								//Gesture
								{
									stack_var integer nChan
									
									(*!
									send_string 0,"'*********** LINEAR SLIDER', itoa(nSrc), ' X=', itoa(nXPos), ' Y=', itoa(nYPos), ' CHAN=', itoa(nChan)"
									!*)
									
									if(!timeline_active(tlLockOut[nSrc]))
									{
										select
										{
											//Swipe Up
											active((nXPos == 0) and (nYPos < snGTLOW)):		{nChan = 33}
											
											//Swipe Down
											active((nXPos == 0) and (nYPos > snGTHIGH)):		{nChan = 34}
											
											//Swipe Left
											active((nXPos < snGTLOW) and (nYPos == 0)):		{nChan = 35}
											
											//Swipe Right
											active((nXPos > snGTHIGH) and (nYPos == 0)):		{nChan = 36}
											
											//None of the above
											active(1):													{nChan = 0}
										}	
										
										if(nchan <> 0)
										{
											//prevent gestures and button presses
											fnLockOut(nSrc, 1)
											
											do_push(vdaUUI_Int[nSrc], nChan)
											send_string 0,"'*** GESTURE  ', itoa(nSrc), ' CHAN=', itoa(nChan)"
										}
																				
										//Update levels in main program (Removed as these are not absolute position values)
										//send_level vdaUUI_Int[nSrc], 4, nXPos
										//send_level vdaUUI_Int[nSrc], 5, nYPos
									}
								}
								
								
								//Buttons
								{
									for(nBit = 1; nBit <= nNUMBUTTONS; nBit++)
									{
										nNewBtnState = (lPressed band nBITMASK32[nBit] > 0)
										
										if(xUUI[nSrc].nBtn[nBit] <> nNewBtnState)
										{
											if(nNewBtnState == 1)
											{
												if(!timeline_active(tlLockOut[nSrc]))
												{
													send_string 0,"'***********   PUSH[', itoa(nSrc), ',', itoa(nBit), ']'"
													do_push_timed(vdaUUI_Int[nSrc], nBit, DO_PUSH_TIMED_INFINITE)
												}
											}
											else
											{
												send_string 0,"'*********** RELESE[', itoa(nSrc), ',', itoa(nBit), ']'"
												do_release(vdaUUI_Int[nSrc], nBit)
											}
										}
										xUUI[nSrc].nBtn[nBit] = nNewBtnState
									}
								}
								
	
	
								fnDebug(16, "'UUI_COM fnParseUUI: Touch_Event_Rep #', itoa(nSrc)")
								fnDebug(16, "'lPressed     = ', itoa(lPressed)")
								fnDebug(16, "'lChanged     = ', itoa(lChanged)")
								fnDebug(16, "'nSliders[]   = ', itoa(nSlider[1]), ', ', itoa(nSlider[3]), ', ', itoa(nSlider[3])")
								fnDebug(16, "'nXPos, nYPos = ', itoa(nXPos), ', ', itoa(nYPos)")
							}
							
							
							
							
							//----------------------------------------------------
							case	$0225:	//Startup_Rep
							//----------------------------------------------------
							{
								//Reset all button and level feedback to main program &
								//Channels from main program
								
								on[nInhibitComms]	//Disable comms to prevent channel changes sending messages to physical device
								
								for(nTmp = 1; nTmp <= nNUMBUTTONS; nTmp++)
								{
									do_release(vdaUUI_Int[nSrc], nTmp)
									off[vdaUUI_Ext[nSrc],nTmp]		//Reset channels to device
								}
								send_level vdaUUI_Int[nSrc], 1, 0
								send_level vdaUUI_Int[nSrc], 2, 0
								send_level vdaUUI_Int[nSrc], 3, 0
								
								off[nInhibitComms]	//Re-enable comms
								
								//Set slider range to fixed value
								for(nTmp = 1; nTmp <= length_array(vdaUUI_Ext); nTmp++)
								{
									fnTxQueue_Add (nTmp, "cmdSLIDER_RANGE, 1, raw_be(360)", 2)
									fnTxQueue_Add (nTmp, "cmdSLIDER_RANGE, 2, raw_be(360)", 2)
									fnTxQueue_Add (nTmp, "cmdSLIDER_RANGE, 3, raw_be(360)", 2)
								}
								
								//Request Initialisation of UUI
								send_string vdaUUI_Int[nSrc],'INITIALISE'
								
								fnDebug(16, "'UUI_COM fnParseUUI: Startup_Rep #', itoa(nSrc)")
							}
							
							
							
							//----------------------------------------------------
							case	$0226:	//Sleep_Rep
							//----------------------------------------------------
							{
								send_string vdaUUI_Int[nSrc],'SLEEP'
	
								fnDebug(16, "'UUI_COM fnParseUUI: Sleep_Rep #', itoa(nSrc)")
							}
							
							
							
							//----------------------------------------------------
							case	$0227:	//Wake_Rep
							//----------------------------------------------------
							{
								send_string vdaUUI_Int[nSrc],'WAKE'
	
								fnDebug(16, "'UUI_COM fnParseUUI: Wake_Rep #', itoa(nSrc)")
							}
							
							
							
							//----------------------------------------------------
							default:		//Invalid command for UUI>HOST
							//----------------------------------------------------
							{
								fnDebug(1, "'UUI_COM fnParseUUI: Invalid command!'")
							}
						}
					}
				}
			}
		}
	}
}


define_function fnLockOut(integer nIndex, integer nState)
{
	if(timeline_active(tlLockOut[nIndex]))
	{
		timeline_kill(tlLockOut[nIndex])
	}
	
	if(nState <> 0)	//Clear lock
	{
		timeline_create(tlLockOut[nIndex], taLockOut, length_array(taLockOut), timeline_absolute, timeline_once) 
	}
}





//##############################################################################
DEFINE_CONNECT_LEVEL					//#############################################
//##############################################################################





//##############################################################################
DEFINE_START							//#############################################
//##############################################################################

create_buffer dvUUI, sRxUUI

fnTxQueue_Init ()

//Build internal device array and transalte from extrenal to internal
{
	stack_var nIndex
	
	for(nIndex = 1; nIndex <= length_array(vdaUUI_Ext); nIndex++)
	{
		//This can not be done in defined variables as dynamic virtual devices
		//have not been defined at that point
		set_length_array(vdaUUI_Int, nIndex)
		
		switch(nIndex)
		{
			case 01:	{ vdaUUI_Int[nIndex] = vdUUI_Int_01 }
			Case 02:	{ vdaUUI_Int[nIndex] = vdUUI_Int_02 }
			Case 03:	{ vdaUUI_Int[nIndex] = vdUUI_Int_03 }
			Case 04:	{ vdaUUI_Int[nIndex] = vdUUI_Int_04 }
			Case 05:	{ vdaUUI_Int[nIndex] = vdUUI_Int_05 }
			Case 06:	{ vdaUUI_Int[nIndex] = vdUUI_Int_06 }
			Case 07:	{ vdaUUI_Int[nIndex] = vdUUI_Int_07 }
			Case 08:	{ vdaUUI_Int[nIndex] = vdUUI_Int_08 }
		}											
		
		set_virtual_level_count (vdaUUI_Int[nIndex], nNUMBUTTONS + nNUMSLIDERS)
		
		translate_device(vdaUUI_Ext[nIndex], vdaUUI_Int[nIndex])
	}
	
	rebuild_event()
	
	send_string vdaUUI_Int[1],'MODULE_READY'
}





//##############################################################################
DEFINE_EVENT							//#############################################
//##############################################################################





////////////////////////////////////////////////////////////////////////////////
//CHANNEL EVENTS 						///////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

channel_event[vdaUUI_Int, 0]
{
	on:
	{
		stack_var integer nUUI
		stack_var integer nbutton
		
		nUUI	= get_last(vdaUUI_Int)
		nbutton = channel.channel
		
		//!fnDebug(3, "'[vdaUUI_Int[',itoa(nUUI),'], ', itoa(nbutton), '] Channel On'")
		
		if((nButton > 0) and (nbutton <= nNUMBUTTONS))
		{
			fnTxQueue_Add (nUUI, "cmdFIELD_ON, nButton", 2)
		}
	}
	off:
	{
		stack_var integer nUUI
		stack_var integer nbutton
		
		nUUI	= get_last(vdaUUI_Int)
		nbutton = channel.channel
		
		//!fnDebug(3, "'[vdaUUI_Int[',itoa(nUUI),'], ', itoa(nbutton), '] Channel Off'")
		
		if((nButton > 0) and (nbutton <= nNUMBUTTONS))
		{
			fnTxQueue_Add (nUUI, "cmdFIELD_OFF, nButton", 2)
		}
	}
}





////////////////////////////////////////////////////////////////////////////////
//LEVEL_ EVENTS						///////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

level_event[vdaUUI_Int, 0]
{
	stack_var integer nUUI
	stack_var integer nButton
	stack_var integer nValue
	
	nUUI	= get_last(vdaUUI_Int)
	nButton	= level.input.level
	nValue	= level.value
	
	if((nButton > 0) and (nbutton <= nNUMBUTTONS))
	{
		if((nValue <= 100) or ((nValue >= 128) and (nValue <= 228)))
		{
			fnTxQueue_Add (nUUI, "cmdBAR_WRITE, nButton, nValue", 2)
		}
	}
}





////////////////////////////////////////////////////////////////////////////////
//DATA EVENTS 							///////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------
data_event[dvUUI]
//----------------------------------------------------------
{
	online:
	{
		send_command data.device,"'SET BAUD 38400,N,8,1 485 ENABLE'"
		send_command data.device, 'HSOFF'
		send_command data.device, 'XOFF'
		send_command data.device, 'CHARD-0'
		send_command data.device, 'B9MOFF'
		send_command data.device, 'CTSPSH OFF'
	}
	
	string:
	{
		fnParseUUI()
	}
	
	command:
	{
	}
}





//----------------------------------------------------------
data_event[vdaUUI_Int]
//----------------------------------------------------------
{
	string:
	{
	}
	
	command:
	{
		stack_var integer	nUUI
		stack_var integer	nLoop
		
		stack_var char		sData[255]
		stack_var integer	nPos
		stack_var integer	nDelimPos
		
		stack_var char		sCmd[255]
		stack_var char		sUCmd[255]
		stack_var char		sParam[5][96]
		stack_var integer	nParam[5]
		stack_var integer	nParamIndex
		
		stack_var integer	i
		
		stack_var sinteger	sResult
		
		
		
		
		
		//-------------------------------------------
		//Extract command and paramiters
		//-------------------------------------------
		nUUI = get_last(vdaUUI_Int)
		
		sData = data.text
		
		//set maximum number of loops to perform
		nLoop = max_length_array(sParam) + 1
		
		//Extract command and paramiters
		while (length_string(sData) and (nLoop))
		{
			nLoop--
			nDelimPos = length_string(sData) + 1
			
			//Find next delimiter
			nPos = find_string(sData, '-', 1)
			if(nPos and (nPos < nDelimPos))	nDelimPos = nPos
			nPos = find_string(sData, ':', 1)
			if(nPos and (nPos < nDelimPos))	nDelimPos = nPos
			nPos = find_string(sData, ',', 1)
			if(nPos and (nPos < nDelimPos))	nDelimPos = nPos
			
			if(sCmd <> '')	nParamIndex++
			
			//Extract data
			if(sCmd = '')	sCmd = get_buffer_string(sData, nDelimPos - 1)		//Extract command
			else
			{
				sParam[nParamIndex] = get_buffer_string(sData, nDelimPos - 1)	//Extract paramiter
				nParam[nParamIndex]= atoi(sParam[nParamIndex])
			}
			
			get_buffer_char(sData)															//Junk delimiter
		}
		
		sUCmd = upper_string(sCmd)

		
		
		//-------------------------------------------
		//Process commands
		//-------------------------------------------
		
		select
		{
			//----------------------------------------------------
			active(sUCmd = '^TXT'):
			//----------------------------------------------------
			{	//Set the text value of the specified field
				if((nParam[1] > 0) and (nParam[1] <= nNUMBUTTONS))
				{
					//Message may contains aditional delimiters	e.g. ':=-,'
					//Manualy parse string ignoring subseqent delimiters.
					sData = data.text			
					remove_string(sData, ',', 1)
					
					sData = upper_string(sData)	//UUI can only show uppercase chars
					
					//%%Note -	Total length of message on AMX serial port can not exceed 64bytes
					//				Therfore string length limited 44 inc null terminator
					//				unless we send msg in parts.
					sData = "left_string(sData, 43), $00"
					
					fnTxQueue_Add (nUUI, "cmdTEXT_WRITE, nParam[1], sData", 2)
				}
			}
			
			
			
			//----------------------------------------------------
			active(sUCmd = '^JST'):
			//----------------------------------------------------
			{	//Set the text value of the specified field
				if((nParam[1] > 0) and (nParam[1] <= nNUMBUTTONS))
				{
					if((nParam[2] > 0) and (nParam[2] <= 9))
					{
						fnTxQueue_Add (nUUI, "cmdTEXT_ALIGHNMENT, nParam[1], nParam[2]", 2)
					}
				}
			}
			
			
			
			//----------------------------------------------------
			active(sUCmd = 'PULSE'):
			//----------------------------------------------------
			{	//Pulse the specified button
				if((nParam[1] > 0) and (nParam[1] <= nNUMBUTTONS))
				{
					fnTxQueue_Add (nUUI, "cmdFIELD_PULSE, nParam[1]", 2)
				}
			}
			
			
			
			//----------------------------------------------------
			active(sUCmd = 'PAGE'):
			//----------------------------------------------------
			{	//Flip to specified predertemined page layout
				if((nParam[1] > 0) and (nParam[1] <= nNUMPAGES))
				{
					fnTxQueue_Add (nUUI, "cmdPAGE_ACTIVATE, nParam[1]", 2)
				}
			}
			
			
			
			//----------------------------------------------------
			active(sUCmd = '@PPN'):
			//----------------------------------------------------
			{	//Show the specified popup page
				if((nParam[1] > 0) and (nParam[1] <= nNUMPOPUPS))
				{
					fnTxQueue_Add (nUUI, "cmdPOPUP_ACVTIVTE, nParam[1]", 2)
				}
			}
			
			
			
			//----------------------------------------------------
			active(sUCmd = '@PPF'):
			//----------------------------------------------------
			{	//Hide the specified popup page
				if((nParam[1] > 0) and (nParam[1] <= nNUMPOPUPS))
				{
					fnTxQueue_Add (nUUI, "cmdPOPUP_DEACTIVATE, nParam[1]", 2)
				}
			}
			
			
			
(*! Not currently implimented because levels returned from UUI not absolute
			//----------------------------------------------------
			active(sUCmd = 'SLIDERARC'):
			//----------------------------------------------------
			{
				if((nParam[1] >= 1) and (nParam[1] <= nNUMSLIDERS) and
					(nParam[2] <= 65535))
				{
					//Adjust panel slider range
					fnTxQueue_Add (nUUI, "cmdSLIDER_RANGE, nParam[1], raw_be(nParam[2])", 2)
				}
			}
!*)			
			
			
(*! Not currently implimented because UUI does not respond
			//----------------------------------------------------
			active(sUCmd = '@BRT'):
			//----------------------------------------------------
			{
				//Adjust panel brightness
				if((nParam[1] <=31) and (nParam[2] <= 31))
				{
					fnTxQueue_Add (nUUI, "cmdPANEL_BRIGHTNESS, nParam[1], nParam[2]", 2)
				}
			}
!*)			
			
			
			//----------------------------------------------------
			active(sUCmd = 'ECO_MODE'):
			//----------------------------------------------------
			{	//Flip to specified predertemined page layout
				switch(nParam[1])
				{
					case 1:	fnTxQueue_Add (nUUI, "cmdECO_ON", 2)
					default: fnTxQueue_Add (nUUI, "cmdECO_OFF", 2)
				}
			}
			
			
			
			//----------------------------------------------------
			active(sUCmd = 'TEST'):
			//----------------------------------------------------
			{	//test connection to UUI
				fnTxQueue_Add (nUUI, "cmdECO_OFF", 1)
				//!Note this disables eco mode
			}
			
			
			
			//----------------------------------------------------
			active(sUCmd = 'DEBUG'):
			//----------------------------------------------------
			{	//Set debug message mode
				nDebug = nParam[1]
			}
			
			
			
			//----------------------------------------------------
			active(sUCmd = 'PASSTHRU'):
			//----------------------------------------------------
			{
				sData = data.text			
				remove_string(sData, 'PASSTHRU-', 1)
				fnTxQueue_Add (nUUI, "sData", 1)
			}
			
			

			//----------------------------------------------------
			active(sUCmd = 'VERSION?'):
			//----------------------------------------------------
			{
				sData = upper_string("__FILE__")
				remove_string(sData, 'V', 1)
				
				sParam[1] = remove_string(sData, '_', 1)
				set_length_string(sParam[1], length_string(sParam[1]) - 1)
				
				
				sParam[2] = remove_string(sData, '.', 1)
				set_length_string(sParam[2], length_string(sParam[2]) - 1)
				
				send_string vdaUUI_Int[nUUI],"'VERSION=', sParam[1],'.', sParam[2]"
			}


			
			//----------------------------------------------------
			active(left_string(sUCmd, 3) = 'UI_'):
			//----------------------------------------------------
			{	//This is command for the UI module.  Now that we have translated addresses
				//the UI module wont see it unless we pass it back
				send_command vdaUUI_Int[nUUI],"data.text"
			}
			

			
			//----------------------------------------------------
			active(1):
			//----------------------------------------------------
			{
				send_command vdaUUI_Int[nUUI],"'UNKNOWN COMMAND [', data.text, ']'"
			}
			
		}
	}
}



//##############################################################################
DEFINE_PROGRAM							//#############################################
//##############################################################################


wait 10 'UUI_TIMEOUT'
{
	local_var integer nUUI
	
	for(nUUI = length_array(vdaUUI_Int); nUUI; nUUI--)
	{
		if(xUUI[nUUI].nWaiting == 1)
		{
			off[vdaUUI_Int[nUUI], DEVICE_COMMUNICATING]	//Clear online channel
			off[vdaUUI_Int[nUUI], DATA_INITIALIZED]
		}
		if(xUUI[nUUI].nWaiting > 0)  {xUUI[nUUI].nWaiting--}
	}
}

fnTxQueue_Process ()

 

//##############################################################################
//END OF PROGRAM						//#############################################
//##############################################################################